clear all
close all
global ga alpha gi mcs xiw sigma pistar delta eta b beta ys chi

%% parameters
load param_tab
SP=1;
SW=1;
varrhop=varrho;
varrhow=varrho;
sigma=4;
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
theta = 4; % elasticity substitution goods
zetap = 0; % indexation price
zetaw = 0; % indexation wage
chi = 1; % Frisch elasticity
eta = 6; % labor disutility
pistar = 1.008675; % steady state gross inflation
alpha = 1/3; % Cobb-Douglas parameter
phi = 0; % Cobb-Douglas parameter
%phi = 0.6;
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth
psik = 0;
psig = 0;
psil = 0;
% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
gid = 1.00472; % desired growth of IST
gyd = 1.005712; % desired growth of output
gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
ga = gad^(1-phi); % growth of neutral prod
gi = gid; % growth of IST
gup = ga^(1/((1-phi)*(1-alpha)))*gi^(alpha/(1-alpha)); % growth of upsilon


if SP==1
    xip = 0.55;
else
    xip=0;
end

if SW==1
    xiw = 0.66;
else
    xiw=0;
end

%% Compute initial values (steady state)
run solve_for_steady_state_endog_spsw
shock_sizes_stoch_endog_spsw;
    
for pistar=[1 (1+7/100)^0.25]
    solve_for_steady_state_endog_spsw
    save param_main_stochastic_endog_spsw beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws xipss xiwss varrhop varrhow
    dynare base_stochastic_endog_spsw noclearall nolog
    moments_endog_spsw;
end
%% getting welfare tables 
load param_tab;
welfarecost_0_to_7_ss = 1 - exp((1-beta)*(SS(2,1) - SS(1,1)));
xiw_endo=xiw/(pistar^varrho);
xip_endo=xip/(pistar^varrho);
wait_time_price_quarter=3*(1/(1-xip_endo));
wait_time_wage_quarter=3*(1/(1-xiw_endo));
