%November 2018

% Long-Run Inflation and the Distorting Effects of Sticky Wages and 
%Technical ChangeLong-Run Inflation and the Distorting Effects of 
%Sticky Wages and Technical Change

%%%%%%%%%%%%
% FIGURE 1 % 
%%%%%%%%%%%%


clear all
close all
clc

%% Panel 1
clear all
close all
clc
 price_dis_0_55a=[];
 price_dis_0_66a=[];
 price_dis_0_75a=[];
 price_dis_0_82a=[];
 save pd_tab_0_55a price_dis_0_55a
 save pd_tab_0_66a price_dis_0_66a 
 save pd_tab_0_75a price_dis_0_75a 
 save pd_tab_0_82a price_dis_0_82a 
 
 for xip=[0.55 0.66 0.75 0.82]
for pistar=linspace(1, (1+12/100)^0.25, 12)


beta = 0.99;
gammap = 0;
gammaw = 0;

theta=4;
chi = 0;
eta = 1;

% monetary policy
rhoi = 0.8;
alphapi = 1.5;
alphay = 0.2;

rhoA = 0.95;
rhor=0;


% Compute initial values (steady state)
solve_for_steady_state_SNKM;


sur=0.002;
suA=0.009;

save parameter_SNKM beta pistar chi eta theta xip gammap alphapi alphay rhoi rhoA rhor suA sur ints ys lams ls ws ps x1s x2s mcs ss As css;
dynare SNKM noclearall nolog
save param_tab xip theta

if xip==0.55
        load pd_tab_0_55a
        price_dis_0_55a=[price_dis_0_55a; pistar oo_.steady_state(9)];
        save pd_tab_0_55a price_dis_0_55a 
elseif xip==0.66
        load pd_tab_0_66a
        price_dis_0_66a=[price_dis_0_66a; pistar oo_.steady_state(9)];
        save pd_tab_0_66a price_dis_0_66a
       
elseif xip==0.75
        load pd_tab_0_75a
        price_dis_0_75a=[price_dis_0_75a; pistar oo_.steady_state(9)];
        save pd_tab_0_75a price_dis_0_75a
elseif xip==0.82
        load pd_tab_0_82a
        price_dis_0_82a=[price_dis_0_82a; pistar oo_.steady_state(9)];
        save pd_tab_0_82a price_dis_0_82a
end

end
 end 
 
%% Panel 2

clear all
close all
clc
 price_dis_2=[];
 price_dis_4=[];
 price_dis_6=[];
 price_dis_8=[];
 price_dis_11=[];
 save pd_tab_2 price_dis_2 
 save pd_tab_4 price_dis_4 
 save pd_tab_6 price_dis_6 
 save pd_tab_8 price_dis_8 
 save pd_tab_11 price_dis_11
 %for xip=[0.55 0.66 0.75 0.82]

for theta=[2 4 6 8 11]
for pistar=linspace(1, (1+12/100)^0.25, 12)
xip =0.55;
beta = 0.99;
gammap = 0;
gammaw = 0;
chi = 0;
eta = 1;

% monetary policy
rhoi = 0.8;
alphapi = 1.5;
alphay = 0.2;

rhoA = 0.95;
rhor=0;


% Compute initial values (steady state)
solve_for_steady_state_SNKM;


sur=0.002;
suA=0.009;

save parameter_SNKM beta pistar chi eta theta xip gammap alphapi alphay rhoi rhoA rhor suA sur ints ys lams ls ws ps x1s x2s mcs ss As css;
dynare SNKM noclearall nolog
save param_tab xip theta

if theta==2
        load pd_tab_2
        price_dis_2=[price_dis_2; pistar oo_.steady_state(9)];
        save pd_tab_2 price_dis_2 
elseif theta==4
        load pd_tab_4
        price_dis_4=[price_dis_4; pistar oo_.steady_state(9)];
        save pd_tab_4 price_dis_4
       
elseif theta==6
        load pd_tab_6
        price_dis_6=[price_dis_6; pistar oo_.steady_state(9)];
        save pd_tab_6 price_dis_6
        
elseif theta==8
        load pd_tab_8
        price_dis_8=[price_dis_8; pistar oo_.steady_state(9)];
        save pd_tab_8 price_dis_8
        
elseif theta==11
        load pd_tab_11
        price_dis_11=[price_dis_11; pistar oo_.steady_state(9)];
        save pd_tab_11 price_dis_11
end
end
end

%%
 load pd_tab_0_55a 
 load pd_tab_0_66a
 load pd_tab_0_75a 
 load pd_tab_0_82a 

 load pd_tab_2 
 load pd_tab_4
 load pd_tab_6 
 load pd_tab_8
 load pd_tab_11

 T1=price_dis_0_75a(:,1);
 T=(T1.^4-1)*100;
figure
subplot(2,1,1)
plot(T,exp(price_dis_0_55a(:,2)),'-k',T,exp(price_dis_0_66a(:,2)),'--k', T,exp(price_dis_0_75a(:,2)),':k',T,exp(price_dis_0_82a(:,2)),'-+k','Linewidth',1.5)
title('Panel A: Inflation-Price Dispersion Relation (  \theta = 4)', 'Fontweight', 'normal')
legend('\xi_p = 0.55','\xi_p = 0.66','\xi_p = 0.75','\xi_p = 0.82','Location','Northwest')
xlabel('Steady State Inflation ( \pi)')
ylabel('Price Dispersion (\upsilon^p)')

subplot(2,1,2)
plot(T,exp(price_dis_4(:,2)),'-k', T,exp(price_dis_6(:,2)),'--k',T,exp(price_dis_8(:,2)),':k',T,exp(price_dis_11(:,2)),'-+k','Linewidth',1.5)
title('Panel B: Inflation-Price Dispersion Relation (  \xi_p = 0.55)', 'Fontweight', 'normal')
legend('\theta = 4','\theta = 6','\theta = 8','\theta = 11', 'Location','Northwest')
xlabel('Steady State Inflation ( \pi)')
ylabel('Price Dispersion (\upsilon^p)')
axis([0 12 1 1.035 ])