

%November 2018

% Long-Run Inflation and the Distorting Effects of Sticky Wages and 
%Technical ChangeLong-Run Inflation and the Distorting Effects of 
%Sticky Wages and Technical Change

%%%%%%%%%%%%
% FIGURE 2 % 
%%%%%%%%%%%%


clear all
close all
clc

%% Panel A
clear all
close all
clc
 wage_dis_0_5=[];
 wage_dis_0_66=[];
 wage_dis_0_75=[];
%  wage_dis_0_8=[];
 save wd_tab_0_5 wage_dis_0_5
 save wd_tab_0_66 wage_dis_0_66 
 save wd_tab_0_75 wage_dis_0_75 

 for xiw=[0.5 0.66 0.75]  % xiw=[0.5 0.66 0.75 0.79]
for pistar=linspace(1, (1+7/100)^0.25, 7)

theta=4;
sigma=4;
xip = 0.55;
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
zetap = 0; % indexation price
zetaw = 0; % indexation wage
chi = 1; % Frisch elasticity
eta = 6; % labor disutility
alpha = 1/3; % Cobb-Douglas parameter
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth
% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
gid = 1.00472; % desired growth of IST
gyd = 1.005712; % desired growth of output
gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
ga = gad; % growth of neutral prod
gi = gid; % growth of IST
gup = ga^(1/(1-alpha))*gi^(alpha/(1-alpha)); % growth of upsilon
suA=0;
suinvs=0;
sur=0;
solve_for_steady_state
save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
dynare base_stochastic noclearall nolog
var_pos_stoch

if xiw==0.5
        load wd_tab_0_5
        wage_dis_0_5=[wage_dis_0_5; pistar oo_.steady_state(p_vw)];
        save wd_tab_0_5 wage_dis_0_5 
elseif xiw==0.66
        load wd_tab_0_66
        wage_dis_0_66=[wage_dis_0_66; pistar oo_.steady_state(p_vw)];
        save wd_tab_0_66 wage_dis_0_66
       
elseif xiw==0.75
        load wd_tab_0_75
        wage_dis_0_75=[wage_dis_0_75; pistar oo_.steady_state(p_vw)];
        save wd_tab_0_75 wage_dis_0_75

end

end
 end
 
%% Panel B

clear all
close all
clc
 wage_dis_2=[];
 wage_dis_4=[];
 wage_dis_6=[];
%  wage_dis_8=[];
%  wage_dis_11=[];
 save wd_tab_2 wage_dis_2 
 save wd_tab_4 wage_dis_4 
 save wd_tab_6 wage_dis_6 
%  save wd_tab_8 wage_dis_8 
%  save wd_tab_11 wage_dis_11
 %for xip=[0.55 0.66 0.75 0.82]

for sigma=[4 5 6]
for pistar=linspace(1, (1+7/100)^0.25, 7)
theta=4;
xip = 0.55;
xiw=0.66;
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
zetap = 0; % indexation price
zetaw = 0; % indexation wage
chi = 1; % Frisch elasticity
eta = 6; % labor disutility
alpha = 1/3; % Cobb-Douglas parameter
phi = 0; % Cobb-Douglas parameter
%phi = 0.6;
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth
psik = 0;
psig = 0;
psil = 0;
% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
gid = 1.00472; % desired growth of IST
gyd = 1.005712; % desired growth of output
gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
ga = gad; % growth of neutral prod
gi = gid; % growth of IST
gup = ga^(1/(1-alpha))*gi^(alpha/(1-alpha)); % growth of upsilon
suA=0;
suinvs=0;
sur=0;
solve_for_steady_state
save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
dynare base_stochastic noclearall nolog
var_pos_stoch
if sigma==4
        load wd_tab_2
        wage_dis_2=[wage_dis_2; pistar oo_.steady_state(p_vw)];
        save wd_tab_2 wage_dis_2 
elseif sigma==5
        load wd_tab_4
        wage_dis_4=[wage_dis_4; pistar oo_.steady_state(p_vw)];
        save wd_tab_4 wage_dis_4
       
elseif sigma==6
        load wd_tab_6
        wage_dis_6=[wage_dis_6; pistar oo_.steady_state(p_vw)];
        save wd_tab_6 wage_dis_6
end
end
end


%% Panel C
clear all
close all
clc
 wage_dis_noG=[];
 wage_dis_G=[];
 
 save wd_tab_noG wage_dis_noG 
 save wd_tab_G wage_dis_G 

for growth=[0 1]
%     sigma=[2 4 6 8 11]
for pistar=linspace(1, (1+7/100)^0.25, 7)
xip=0.55;
xiw=0.66;
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
theta = 4; % elasticity substitution goods
sigma=4;
zetap = 0; % indexation price
zetaw = 0; % indexation wage
chi = 1; % Frisch elasticity
eta = 6; % labor disutility
%pistar = 1.008675; % steady state gross inflation
alpha = 1/3; % Cobb-Douglas parameter
phi = 0; % Cobb-Douglas parameter
%phi = 0.6;
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth
psik = 0;
psig = 0;
psil = 0;
% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
if growth==1
    gid = 1.00472; % desired growth of IST
    gyd = 1.005712; % desired growth of output
    gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
    ga = gad; % growth of neutral prod
    gi = gid; % growth of IST
    gup = ga^(1/(1-alpha))*gi^(alpha/(1-alpha)); % growth of upsilon
else
    ga = 1; % growth of neutral prod
    gi = 1; % growth of IST
    gup = 1;
end
suA=0;
suinvs=0;
sur=0;

% Compute initial values (steady state)
solve_for_steady_state
save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
dynare base_stochastic noclearall nolog
var_pos_stoch
if growth==0
        load wd_tab_noG
        wage_dis_noG=[wage_dis_noG; pistar oo_.steady_state(p_vw)];
        save wd_tab_noG wage_dis_noG 
elseif growth==1
        load wd_tab_G
        wage_dis_G=[wage_dis_G; pistar oo_.steady_state(p_vw)];
        save wd_tab_G wage_dis_G
end
end
end

%% Panel D

%%
%mme chose avec et sans croissance
clear all
close all
clc
 wage_dis_chi_base=[];
 wage_dis_chi_0=[];
  
 save wd_tab_chi_base wage_dis_chi_base 
 save wd_tab_chi_0 wage_dis_chi_0 

for chi=[0 1]
%     sigma=[2 4 6 8 11]
for pistar=linspace(1, (1+7/100)^0.25, 7)
growth=1;
xip=0.55;
xiw=0.66;
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
theta = 4; % elasticity substitution goods
sigma=4;
zetap = 0; % indexation price
zetaw = 0; % indexation wage
%chi = 1; % Frisch elasticity
eta = 6; % labor disutility
%pistar = 1.008675; % steady state gross inflation
alpha = 1/3; % Cobb-Douglas parameter;
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth
psik = 0;
psig = 0;
psil = 0;
% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
if growth==1
    gid = 1.00472; % desired growth of IST
    gyd = 1.005712; % desired growth of output
    gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
    ga = gad; % growth of neutral prod
    gi = gid; % growth of IST
    gup = ga^(1/(1-alpha))*gi^(alpha/(1-alpha)); % growth of upsilon
else
    ga = 1; % growth of neutral prod
    gi = 1; % growth of IST
    gup = 1;
end
suA=0;
suinvs=0;
sur=0;

% Compute initial values (steady state)
solve_for_steady_state
save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
dynare base_stochastic noclearall nolog
var_pos_stoch
if chi==1
        load wd_tab_chi_base
        wage_dis_chi_base=[wage_dis_chi_base; pistar oo_.steady_state(p_vw)];
        save wd_tab_chi_base wage_dis_chi_base 
elseif chi==0
        load wd_tab_chi_0
        wage_dis_chi_0=[wage_dis_chi_0; pistar oo_.steady_state(p_vw)];
        save wd_tab_chi_0 wage_dis_chi_0
end
end
end


%% Figure

load wd_tab_0_5 
load wd_tab_0_66
load wd_tab_0_75 

load wd_tab_2 
load wd_tab_4
load wd_tab_6

load wd_tab_noG 
load wd_tab_G
 
load wd_tab_chi_base 
load wd_tab_chi_0 
 
T1=wage_dis_0_75(:,1);
T=(T1.^4-1)*100;
figure
subplot(2,2,1)
plot(T,exp(wage_dis_0_5(:,2)),'--k',T,exp(wage_dis_0_66(:,2)),'-k', T,exp(wage_dis_0_75(:,2)),':k','Linewidth',1.5)
title('Panel A: Sensitivity to \xi_w', 'Fontweight', 'normal')
legend('\xi_w = 0.5','\xi_w = 0.66','\xi_w = 0.75', 'Location','Northwest')
xlabel('Steady State Inflation (\pi)')
ylabel('Wage Dispersion (\upsilon^w)')
axis([0 7 1 1.4])


subplot(2,2,2)
plot(T,exp(wage_dis_2(:,2)),'-k', T,exp(wage_dis_4(:,2)),'--k',T,exp(wage_dis_6(:,2)),':k','Linewidth',1.5)
title('Panel B: Sensitivity to \sigma', 'Fontweight', 'normal')
legend('\sigma =4 ','\sigma = 5','\sigma = 6', 'Location','Northwest')
xlabel('Steady State Inflation (\pi)')

ylabel('Wage Dispersion (\upsilon^w)')
axis([0 7 1 1.4])

subplot(2,2,3)
plot(T,exp(wage_dis_noG(:,2)),'--k', T,exp(wage_dis_G(:,2)),'-k','Linewidth',1.5)
title('Panel C: Sensitivity to Growth', 'Fontweight', 'normal')
legend('No Growth','Growth', 'Location','Northwest')
xlabel('Steady State Inflation (\pi)')
ylabel('Wage Dispersion(\upsilon^w)')
axis([0 7 1 1.15 ])

subplot(2,2,4)
plot(T,exp(wage_dis_chi_base(:,2)),'-k', T,exp(wage_dis_chi_0(:,2)),'--k','Linewidth',1.5)
title('Panel D: Sensitivity to \chi', 'Fontweight', 'normal')
legend('\chi=1','\chi=0', 'Location','Northwest')
xlabel('Steady State Inflation (\pi)')
ylabel('Wage Dispersion (\upsilon^w)')
axis([0 7 1 1.15])
