

%November 2018

% Long-Run Inflation and the Distorting Effects of Sticky Wages and 
%Technical ChangeLong-Run Inflation and the Distorting Effects of 
%Sticky Wages and Technical Change

%%%%%%%%%%%%
% FIGURE 3 % 
%%%%%%%%%%%%


clear all
clc
run base_models

SP=1; SW=1; sigma=4;Growth=1;
save param_tab SP SW sigma Growth

for ST=[0 1]
if ST==1

     run execute_base_stochastic 
     ST_IRF_tech=[vp_irf(:,1) vw_irf(:,1) pr_irf(:,1) wr_irf(:,1)];  
     ST_IRF_mon=[vp_irf(:,2) vw_irf(:,2) pr_irf(:,2) wr_irf(:,2)];  
     ST_IRF_IST=[vp_irf(:,3) vw_irf(:,3) pr_irf(:,3) wr_irf(:,3)];  
     save ST_IRF_revised ST_IRF_tech ST_IRF_mon  ST_IRF_IST
else
    run execute_base_deterministic
    DT_IRF_tech=[vp_irf(:,1) vw_irf(:,1) pr_irf(:,1) wr_irf(:,1)];  
    DT_IRF_mon=[vp_irf(:,2) vw_irf(:,2) pr_irf(:,2) wr_irf(:,2)];  
    DT_IRF_IST=[vp_irf(:,3) vw_irf(:,3) pr_irf(:,3) wr_irf(:,3)];  
    save DT_IRF_revised DT_IRF_tech DT_IRF_mon  DT_IRF_IST

end

end


%% Compute IRF
load ST_IRF_revised
load DT_IRF_revised
t=1:20;

%% Price dispersion
figure
subplot(4,3,1)
plot(t,DT_IRF_mon(1:20,1),'k',t,DT_IRF_mon(61:80,1),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_mon(1:20,1),'-+k',t,ST_IRF_mon(61:80,1),':k','Linewidth',1.5)
title('Panel A: Monetary Shock', 'fontweight','normal','FontSize', 9)
ylabel('Price Dispersion')

subplot(4,3,2)
plot(t,DT_IRF_tech(1:20,1),'k',t,DT_IRF_tech(61:80,1),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_tech(1:20,1),'-+k',t,ST_IRF_tech(61:80,1),':k','Linewidth',1.5)
title('Panel B: Technology Shock','fontweight','normal', 'FontSize', 9)


subplot(4,3,3)
plot(t,DT_IRF_IST(1:20,1),'k',t,DT_IRF_IST(61:80,1),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_IST(1:20,1),'-+k',t,ST_IRF_IST(61:80,1),':k','Linewidth',1.5)
title('Panel C: IST shock','fontweight','normal','FontSize', 9)


%% Wage Dispersion 
subplot(4,3,4)
plot(t,DT_IRF_mon(1:20,2),'k',t,DT_IRF_mon(61:80,2),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_mon(1:20,2),'-+k',t,ST_IRF_mon(61:80,2),':k','Linewidth',1.5)
ylabel('Wage Dispersion')

subplot(4,3,5)
plot(t,DT_IRF_tech(1:20,2),'k',t,DT_IRF_tech(61:80,2),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_tech(1:20,2),'-+k',t,ST_IRF_tech(61:80,2),':k','Linewidth',1.5)


subplot(4,3,6)
plot(t,DT_IRF_IST(1:20,2),'k',t,DT_IRF_IST(61:80,2),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_IST(1:20,2),'-+k',t,ST_IRF_IST(61:80,2),':k','Linewidth',1.5)


%% Price Setting 
subplot(4,3,7)
plot(t,DT_IRF_mon(1:20,3),'k',t,DT_IRF_mon(61:80,3),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_mon(1:20,3),'-+k',t,ST_IRF_mon(61:80,3),':k','Linewidth',1.5)
ylabel('Price Setting')

subplot(4,3,8)
plot(t,DT_IRF_tech(1:20,3),'k',t,DT_IRF_tech(61:80,3),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_tech(1:20,3),'-+k',t,ST_IRF_tech(61:80,3),':k','Linewidth',1.5)


subplot(4,3,9)
plot(t,DT_IRF_IST(1:20,3),'k',t,DT_IRF_IST(61:80,3),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_IST(1:20,3),'-+k',t,ST_IRF_IST(61:80,3),':k','Linewidth',1.5)
 

%% Wage Setting

subplot(4,3,10)
plot(t,DT_IRF_mon(1:20,4),'k',t,DT_IRF_mon(61:80,4),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_mon(1:20,4),'-+k',t,ST_IRF_mon(61:80,4),':k','Linewidth',1.5)
ylabel('Wage Setting')

subplot(4,3,11)
plot(t,DT_IRF_tech(1:20,4),'k',t,DT_IRF_tech(61:80,4),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_tech(1:20,4),'-+k',t,ST_IRF_tech(61:80,4),':k','Linewidth',1.5)


subplot(4,3,12)
plot(t,DT_IRF_IST(1:20,4),'k',t,DT_IRF_IST(61:80,4),'--k','Linewidth',1.5)
hold on
plot(t,ST_IRF_IST(1:20,4),'-+k',t,ST_IRF_IST(61:80,4),':k','Linewidth',1.5)
legend('\pi* = 0, DT','\pi* = 7, DT', '\pi* = 0, ST', '\pi* = 7, ST', 'Orientation','horizontal')



