
%November 2018

% Long-Run Inflation and the Distorting Effects of Sticky Wages and 
%Technical ChangeLong-Run Inflation and the Distorting Effects of 
%Sticky Wages and Technical Change

%%%%%%%%%%%%
% FIGURE 4 % 
%%%%%%%%%%%%

run aux_fig4
load data_Fig4

subplot(2,1,1)
h3_1_curve=plot(t, mylabor,'-k','Linewidth',1.5); 
hold on
h3_2_corde=plot(X,Y,'-k','Linewidth',1.5); 
hold on
h3_3_hor_line1=plot(OX1,OX2,':k','Linewidth',0.5);
hold on 
h3_4_hor_line2= plot(OY1,OY2,':k','Linewidth',0.5);
hold on 
h3_5_ver_line1=plot(OZ1,OZ2,':k','Linewidth',0.5);
hold on 
h3_6_ver_line2=plot(OZA1,OZA2,':k','Linewidth',0.5);
hold on
h3_7_expected1=plot(Oybar_sc1,Oybar_sc2,':k','Linewidth',1);
hold on
h3_8_expected2=plot(Oybar1,Oybar2,':k','Linewidth',0.5);
hold on
plot(Oysc1,Oysc2,':k','Linewidth',0.5) 
hold on
plot(Oy1,Oy2,':k','Linewidth',0.5)
hold on
xlim([xlim1 xlim2])
set(gca,'XTick',[0.64 0.77 0.9] ,'TickLength', [0 0] ); 
set(gca,'YTick',[0.045 0.15 0.25 0.45],'TickLength', [0 0]  );
ax = gca;
  ax.TickLabelInterpreter='Latex';
  ax.XTickLabel={'$\bar{L}^{hw}_{\pi>0}$', '$\bar{L}_{\pi=0}$', '$\bar{L}^{lw}_{\pi>0}$' };
  ax.FontSize = 10;
 ay=gca;
ay.TickLabelInterpreter='Latex';
ay.YTickLabel={'$-V^{n}(\bar{L}^{hw}_{\pi>0})$','$-V^{n}(\bar{L}_{\pi=0}$)','$-E[V^{n}(\bar{L}_{\pi>0}$)]','$-V^{n}(\bar{L}^{lw}_{\pi>0})$' };
ay.FontSize = 10;
xlabel('Steady State Labor (L)', 'FontSize',10)
ylabel('Disutility of Working (\it-V^{n}({L}))', 'FontSize',10)
ylim([ylim1 0.75])
title('Panel A: Costly Wage Dispersion', 'Fontweight', 'normal', 'FontSize',10)


subplot(2,1,2)
plot(t, mylabor,'-k','Linewidth',1.5)
hold on
plot(X,Y,'-k','Linewidth',1.5)
hold on
plot(M,P,'--k','Linewidth',1.5)
hold on 
plot(ON1,ON2,':k','Linewidth',0.5)
hold on 
plot(OQ1,OQ2,':k','Linewidth',0.5)
hold on 
plot(OZ1,OZ2,':k','Linewidth',0.5)
hold on 
plot(OZA1,OZA2,':k','Linewidth',0.5)
hold on
plot(Oybar_sc1,Oybar_sc2,':k','Linewidth',0.5)
hold on
plot(Oybar1,Oybar2,':k','Linewidth',0.5)
hold on
 plot(Oybar_bc1,Oybar_bc2,':k','Linewidth',0.5)
 hold on
plot(Oysc1,Oysc2,':k','Linewidth',0.5)
hold on
plot(Oy1,Oy2,':k','Linewidth',0.5)
hold on
plot(Oybc1,Oybc2,':k','Linewidth',0.5)
xlim([xlim1 xlim2])
title('Panel B: Costly Wage Dispersion and Technical Change', 'Fontweight', 'normal', 'FontSize',10)
set(gca,'XTick',[0.55 0.64 0.77 0.9 0.98] ,'TickLength', [0 0]); 
 ax = gca;
 ax.TickLabelInterpreter='Latex';
 ax.XTickLabel={'$\bar{L}^{hw}_{\pi>0, g_Y>0}$', '$\bar{L}^{hw}_{\pi>0}$', '$\bar{L}_{\pi=0}$','$\bar{L}^{lw}_{\pi>0}$', '$\bar{L}^{lw}_{\pi>0, g_Y>0}$' };
ax.FontSize = 10;
set(gca,'YTick',[0.15 0.25 0.37],'TickLength', [0 0] );
ay=gca;
ay.TickLabelInterpreter='Latex';
ay.YTickLabel={'$-V^{n}(\bar{L}_{\pi=0}$)','$-E[V^{n}(\bar{L}_{\pi>0}$)]', '$-E[V^{n}(\bar{L}_{\pi>0, g_Y>0}$)]' };

ay.FontSize = 10;                              
ylim([ylim1 0.8])
xlabel('Steady State Labor (L)', 'FontSize',10)
ylabel('Disutility of Working (\it-V^{n}({L}))', 'FontSize',10)
