clear all
close all
global ga alpha gi mcs xiw sigma pistar delta eta b beta ys chi

%% parameters

load param_tab
beta = 0.99; % discount factor
b = 0.8; % habit formation
gamma2 = 0.05; % % utilization cost
kappa = 3; % investment adjustment cost
delta = 0.025; % depreciation rate
theta = 4; % elasticity substitution goods
zetap = 0; % indexation price
zetaw = 0; % indexation wage
chi = 1; % Frisch elasticity
eta = 6; % labor disutility
pistar = 1.008675; % steady state gross inflation
alpha = 1/3; % Cobb-Douglas parameter
rhoi = 0.8; % TR smoothing
alphapi = 1.5; % TR inflation
alphay = 0.2; % TR output growth

% shock parameters
rhoA = 0; % stationary TFP
rhoinvs = 0; % no-stationary IST
rhor=0;
gid = 1.00472; % desired growth of IST
gyd = 1.005712; % desired growth of output
gad = (gyd/(gid^(alpha/(1-alpha))))^(1-alpha);
ga = gad; % growth of neutral prod
gi = gid; % growth of IST
gup = ga^(1/(1-alpha))*gi^(alpha/(1-alpha)); % growth of upsilon


if SP==1
    xip = 0.55;
else
    xip=0;
end

if SW==1
    xiw = 0.66;
else
    xiw=0;
end

%% Compute initial values (steady state)
run solve_for_steady_state
shocks_size_stoch;
pistar0 = 1; pistar1 = 1.02^(.25); pistar2 = 1.04^.25; pistar3 = (1.06962)^0.25; pistar4=1.1^0.25;

if SW==1
    
for pistar=[pistar0 pistar1 pistar2 pistar3]
    solve_for_steady_state
    save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
    dynare base_stochastic noclearall nolog
    moments_irf_aux_stoch;
end
%% getting welfare tables 
cons_equiv;


Table_paper_welfa_stoch= 100*[welfarecost_0_to_2_ss welfarecost_0_to_4_ss welfarecost_2_to_4_ss welfarecost_0_to_7_ss;
                    welfarecost_0_to_2_mean welfarecost_0_to_4_mean welfarecost_2_to_4_mean welfarecost_0_to_7_mean;
                    output_lost_0_to_2_ss output_lost_0_to_4_ss output_lost_2_to_4_ss output_lost_0_to_7_ss;
                    output_lost_0_to_2_mean output_lost_0_to_4_mean output_lost_2_to_4_mean output_lost_0_to_7_mean];
                
% Table_paper_welfa_stoch = round(Table_paper_welfa_stoch,2);
                 
Table_paper_wage_disper_stoch=[wage_dis_ss; wage_dis_mean];
Table_paper_6=[Table_paper_welfa_stoch;Table_paper_wage_disper_stoch];
                    
Table_paper_wage_disper_stoch5=[exp(Wage_disper_ss_paper); exp(Wage_disper_mean_paper)];
Table_paper_price_disper_stoch=[exp(Price_disper_ss_paper); exp(Price_disper_mean_paper)];

elseif SW==0
       
for pistar=[pistar0 pistar1 pistar2 pistar3 pistar4]
    solve_for_steady_state
    save param_main beta b gamma1 gamma2 kappa delta theta sigma xiw xip zetaw zetap chi eta pistar alpha rhoi alphapi alphay ga gi gup rhoA suA rhoinvs suinvs sur F ls ys ks cs invss lams x1s x2s f1s f2s ints vps ws wrs lams mcs vws
    dynare base_stochastic noclearall nolog
    moments_irf_aux_stoch;
end
%% getting welfare tables 
cons_equiv;
  Table_paper_welfa_stoch= 100*[welfarecost_0_to_2_ss welfarecost_0_to_4_ss welfarecost_0_to_7_ss welfarecost_0_to_10_ss ;
                    welfarecost_0_to_2_mean welfarecost_0_to_4_mean welfarecost_0_to_7_mean welfarecost_0_to_10_mean ;
                    output_lost_0_to_2_ss output_lost_0_to_4_ss output_lost_0_to_7_ss output_lost_0_to_10_ss ;
                    output_lost_0_to_2_mean output_lost_0_to_4_mean output_lost_0_to_7_mean output_lost_0_to_10_mean ];
% Table_paper_welfa_stoch = round(Table_paper_welfa_stoch,2);
Table_paper_price_disper_stoch=[exp(Price_disper_ss_paper); exp(Price_disper_mean_paper)];
end  